
#ifndef LOCAL_ROUTE_H
#define LOCAL_ROUTE_H

#include "route.h"

/*---------------------------------------------------------------
* Local (to local_route.c)  Declarations
*---------------------------------------------------------------
*/
#define TRIED -2

#define X_SHIFT -50

#define Y_SHIFT -50

extern char net_under_study[];

extern net *Net;		/* Used as a temporary global */

extern int currentPage;		/* The current page on which insertions are being made */

static srange spanRange;

int *levelMap;		 	/* Array used to trace the dependency depth of ranges */
rnglist **reverseDepSets;	/* Array used to trace reverse dependency (break cyles)*/

ilist *congestion = NULL;	/* Indexed list of the tiles w/ worst congestion */
ilist *crossovers = NULL;	/* Indexed list of the tiles w/ worst crossover */


/*--------------------------------------------------------------- 
 * Forward declarations defined in local_route.c
 *---------------------------------------------------------------
 */
void write_local_route_to_file(FILE *f, nlist *nets);
void replace_range_instance(corner *c, corner *newC, int axis);
void dump_ranges(rnglist *rangesToSee);
void reduce_to_least_common_range(srange *target, srange *other);
void old_complete_linkages(tilist *usedTiles, net *n, int setJogsP);
void setup_dependence_levels(int count, rnglist **dChains);
void map_net_into_constraint_sets(net *n);
int form_into_decoupleable_order(rnglist *orderedRanges, int maxRecDepth);
int form_horizontal_ordering(corner *c1, corner *c2);
range *insert_jog(corner *c, corner *linkC, asg_arc *a, int forcedJog);
int constrained_in_x(range *r, corner *c);
int fixed_point_p(range *r1);
int repeated_srange_p(range *r1, range *r2);

#endif // #ifndef LOCAL_ROUTE_H